import 'package:intl/intl.dart';

class ExposureData
{
  /// Total time this user has been in contact with infected devices.
  final Duration duration;
  /// Time at which [duration] was calculated.
  final DateTime dateTime;

  ExposureData(this.duration, this.dateTime);

  @override
  String toString()
  {
    String durationString;
    if (duration.inHours >= 1) {
      final durationGreaterUnit = duration.inHours;
      final durationSmallerUnit = duration.inMinutes - durationGreaterUnit * 60;
      if (durationSmallerUnit > 0)
        durationString = durationGreaterUnit.toString() + "h " + durationSmallerUnit.toString() + "m";
      else
        durationString = durationGreaterUnit.toString() + "h";
    }
    else if (duration.inMinutes >= 1) {
      final durationGreaterUnit = duration.inMinutes;
      final durationSmallerUnit = duration.inSeconds - durationGreaterUnit * 60;
      if (durationSmallerUnit > 0)
        durationString = durationGreaterUnit.toString() + "m " + durationSmallerUnit.toString() + "s";
      else
        durationString = durationGreaterUnit.toString() + "m";
    }
    else {
      durationString = duration.inSeconds.toString() + "s";
    }
    
    return "ExposureData(duration: $durationString, timeOfLatestUpdate: " + DateFormat("yyyy-MM-dd HH:mm:ss").format(dateTime);
  }
}